	ORG $1001-2
	DW  $1001
	
;	DW $100B,0
;	DB $9E,"4109",0,0,0
	
picture	= $B800
 
	; the compressed main part 
	include "target_hex.asm"
	
start
	STY ysave+1
	
	; move character screen to graphics screen
	include "char_to_gfx.asm"
	
	; reveal the new graphics
	include "reveal.asm"
	
	LDA #$0C
	LDY #$00
	LDX #$00
delay	DEX			; delay for a bit and then go
	BNE delay
	DEY
	BNE delay
	SEC
	SBC #$01
	BNE delay
	;
	JSR fade_out

	; switch to textmode
	LDX #$00
	LDA #$20
ct3	STA $0400,x
	STA $0500,x
	STA $0600,x
	STA $0700,x
	INX
	BNE ct3
	;
	LDA #$CC
sync2	CMP $FF1D
	BNE sync2
	;
	LDA #$1B
	STA $FF06
	LDA $FF07
	AND #$40
	ORA #$08
	STA $FF07
	;
	LDA #$C4
	STA $FF12
	LDA #$D1
	STA $FF13
	STX $FF14
	
	; copy buffering text to screen
	LDX #(buffering_text_end-buffering_text)-1
ct1	LDA buffering_text,x
	STA $07DA,x
	LDA #$67		; yellow color
	STA $03DA,x
	DEX
	BPL ct1
	;
	LDX #(counter_lo-counter_hi)-1
ct2	LDA counter_hi,x
	STA $0200,x
	LDA counter_lo,x
	STA $0280,x
	DEX
	BPL ct2
	;
ysave	LDY #$00
	JMP $100D+9		; start decompression
	
fade_out
	SEI
	;
	LDA #$00
	STA lum
	STA col
	;
z0	;LDA #$CC
	;CMP $FF1D
	;BNE *-3
	;DEC $FF19
	;
	LDA $FF15
	AND #$7F
	BEQ fo2
	SEC
	SBC #$10
	BPL fo1
	;
	LDA #$00
fo1	STA $FF15
	STA $FF19
fo2	;
	;
	LDY #$00
	;
	LDA #$78
	STA lum+1
	LDA #$7C
	STA col+1 
	;
z1	LDA (lum),y
	AND #$7F
	TAX
	LDA fadeout1,x
	STA (lum),y
	;
	LDA (col),y
	AND fadeout2,x
	STA (col),y
	;
	INY
	BNE z1
	;
	INC lum+1
	INC col+1
	LDA col+1
	CMP #$80
	BNE z1
	;
z2	;INC $FF19
	LDA $7C00
	BNE z0
	;
	RTS
	
buffering_text
	CMAP "A",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
	DB "BUFFERING: 00%"
	CMAP
buffering_text_end

counter_hi
	;   0               1               2               3
	;   0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcde
	DB ".......99999988888877777666666555554444443333322222211111000000"
counter_lo
	DB ".......98642097643186420976431864209764318642097643186420976431"
counter_end

fadeout1
	DB $00,$00,$01,$02,$03,$04,$05,$06,$00,$00,$01,$02,$03,$04,$05,$06
	DB $00,$00,$01,$02,$03,$04,$05,$06,$00,$00,$01,$02,$03,$04,$05,$06
	DB $10,$10,$11,$12,$13,$14,$15,$16,$10,$10,$11,$12,$13,$14,$15,$16
	DB $20,$20,$21,$22,$23,$24,$25,$26,$20,$20,$21,$22,$23,$24,$25,$26
	DB $30,$30,$31,$32,$33,$34,$35,$36,$30,$30,$31,$32,$33,$34,$35,$36
	DB $40,$40,$41,$42,$43,$44,$45,$46,$40,$40,$41,$42,$43,$44,$45,$46
	DB $50,$50,$51,$52,$53,$54,$55,$56,$50,$50,$51,$52,$53,$54,$55,$56
	DB $60,$60,$61,$62,$63,$64,$65,$66,$60,$60,$61,$62,$63,$64,$65,$66
	
fadeout2
	DB $00,$F0,$F0,$F0,$F0,$F0,$F0,$F0,$00,$F0,$F0,$F0,$F0,$F0,$F0,$F0
	DB $0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	DB $0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	DB $0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	DB $0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	DB $0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	DB $0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	DB $0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF

reveal_map
	include "reveal_map_hex.asm"
	DB $FF,$FF
	
	include "unpack.asm"

	include "packed_hex.asm"
packed_end
